# Signals version 3.2.2.1 Change criteria for the signals
# Purpose: Find the price over ema200 and ema50 and send the results in telegram
# Author: Opfeas

import os
# check if modules are installed otherwise auto install required modules
def check_modules():
    try:
        import xlsxwriter
    except ImportError:
        os.system('pip install xlsxwriter')
    try:
        import socket
    except ImportError:
        os.system('pip install socket')
    try:
        import requests
    except ImportError:
        os.system('pip install requests')    
    try:
        import pandas
    except ImportError:
        os.system('pip install pandas')
    try:
        import openpyxl
    except ImportError:
        os.system('pip install openpyxl')
    try:
        import json
    except ImportError:
        os.system('pip install json')
    try:
        import datetime
    except ImportError:
        os.system('pip install datetime')
    try:
        import errno
    except ImportError:
        os.system('pip install errno')
    try:
        import time
    except ImportError:
        os.system('pip install time')
    try:
        import csv
    except ImportError:
        os.system('pip install csv')
    try:
         import ta
    except ImportError:
          os.system('pip install ta')
                    
       
# Import the required modules
import requests
import pandas as pd
import json
import datetime
import time
import errno
import csv
from datetime import datetime
import ta

timestamp = datetime.now().strftime('%Y-%m-%d_%H-%M-%S')
def path_install(track:str):
    # Check if the os is windows or linux
    if os.name == 'nt':
        path = "c:\\metalink\\"
        # check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(path)):
            try:
                os.makedirs(os.path.dirname(path))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        results = path+"results\\"
        # check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(results)):
            try:
                os.makedirs(os.path.dirname(results))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        config = path+"config\\"
        # check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(config)):
            try:
                os.makedirs(os.path.dirname(config))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        history = path+"history\\"
        # check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(history)):
            try:
                os.makedirs(os.path.dirname(history))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        failed = path+"failed\\"
        # check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(failed)):
            try:
                os.makedirs(os.path.dirname(failed))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        debug = path+"debug\\"
        # check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(debug)):
            try:
                os.makedirs(os.path.dirname(debug))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        atl = path+"history\\alltimelow\\"
        # check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(atl)):
            try:
                os.makedirs(os.path.dirname(atl))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        hour = path+"history\\1hour\\"
        # check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(hour)):
            try:
                os.makedirs(os.path.dirname(hour))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
                
    else:
        # path for linux
        path = "/home/pi/metalink/"
        # Check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname("/home/pi/metalink/")):
            try:
                os.makedirs(os.path.dirname("/home/pi/metalink/"))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise   
        results = path+"results/"
        # Check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(results)):
            try:
                os.makedirs(os.path.dirname(result))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        config = path+"config/"
        # Check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(config)):
            try:
                os.makedirs(os.path.dirname(config))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        history = path+"history/"
        # Check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(history)):
            try:
                os.makedirs(os.path.dirname(history))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        failed = path+"failed/"
        # Check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(failed)):
            try:
                os.makedirs(os.path.dirname(failed))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        debug = path+"debug/"
        # Check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(debug)):
            try:
                os.makedirs(os.path.dirname(debug))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        atl = path+"history/alltimelow/"
        # Check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(atl)):
            try:
                os.makedirs(os.path.dirname(atl))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
        hour = path+"history/1hour/"
        # Check if the path exists otherwise create it
        if not os.path.exists(os.path.dirname(hour)):
            try:
                os.makedirs(os.path.dirname(hour))
            except OSError as exc:
                if exc.errno != errno.EEXIST:
                    raise
                    
    if track == 'config':
        return(config)
    elif track == 'results': 
        return(results)
    elif track == 'history':
        return(history)
    elif track == 'failed':
        return(failed)
    elif track == 'debug':
        return(debug)
    elif track == 'atl':
        return(atl)
    elif track == 'hour':
        return(hour)    
    else: 
        return(path)
    
# Debug function to print the error and exit the script
def debugging(fail,coin_id=None):
    #with open(f"{path_install('debug')}\\{coin_id}.json", 'w') as f:
                #json.dump(fail, f, indent=4)
    print(fail)
    exit()
   
# Fetch the top coins from the CoinGecko API
def fetch_coins(limit):
    url = "https://api.coincap.io/v2/assets"
    params = {
        'limit': limit
    }
    all_coins = []
    response = requests.get(url, params=params)
    if response.status_code == 200:
          all_coins=response.json()
    else:
            print(f"Failed to fetch data by the status: {response.status_code}")
            time.sleep(10)
    #time.sleep(1)  # Respect the API's rate limit
    return all_coins

def modify_time(path,coin_id):
    # Check if the file was created more than 1 hour ago (ignoring minutes and seconds)
    last_modified = os.path.getmtime(f"{path_install(path)}\\{coin_id}.json")
    last_modified_hour = datetime.fromtimestamp(last_modified).hour
    current_hour = datetime.now().hour
    if current_hour - last_modified_hour == 0:
        return True
    return False

# Check the all-time low from 27 July 2022 to the current time
def fetch_all_time_low(coin_id):
    # Current time in unix timestamp milliseconds
    current_time = int(time.time() * 1000)
    # Fetch the all-time low for a coin
    url = f"https://api.coincap.io/v2/assets/{coin_id}/history"
    params = {
            'interval': 'd1',
            # Check the all-time low from 27 July 2022 to the current time
            'start': '1658923364000',
            'end': current_time
        }
    response = requests.get(url, params=params)
    if response.status_code == 200:
        data = response.json()
        prices = data['data']
        # Convert prices to a DataFrame
        df = pd.DataFrame(prices, columns=['priceUsd', 'time', 'date'])
        # Convert priceUsd to float
        df['priceUsd'] = df['priceUsd'].astype(float)
        df = df.sort_values(by='priceUsd', ascending=True).head(1)
        #time.sleep(1)  # Respect the API's rate limit
        return df
    else:
        print(f"Failed to fetch ATL for {coin_id}. Status code: {response.status_code}")
        time.sleep(10)
        return None

def fetch_historical_prices(coin_id,days):
    # Current time in unix timestamp milliseconds
    current_time = int(time.time() * 1000)
    if days == 30:
        # Calculate the start time for the historical prices one month ago
        start_time = current_time - 30 * 24 * 60 * 60 * 1000
    elif days == 365:
        # Calculate the start time for the historical prices one year ago
        start_time = current_time - 365 * 24 * 60 * 60 * 1000
    # Fetch the historical prices for a coin
    url = f"https://api.coincap.io/v2/assets/{coin_id}/history"
    params = {
            'interval': 'h1',
            'start': start_time,
            'end': current_time
        }
    response = requests.get(url, params=params)
    data = response.json()
    if data is None:
        print(f"Failed to fetch historical prices for {coin_id}. Status code: {response.status_code}")
        return None
    prices = data['data']
    # Convert prices to a DataFrame
    df = pd.DataFrame(prices, columns=['priceUsd', 'time', 'circulatingSupply','date'])
    # Convert timestamp to datetime
    df['date'] = pd.to_datetime(df['time'], unit='ms')
    df.set_index('date', inplace=True)
    # Save the DataFrame to a json file in the path {path_install('history')}
    #df.to_json(f"{path_install('hour')}\\{coin_id}.json", orient='records')
    #time.sleep(1)  # Respect the API's rate limit
    return df

def check_file(path,coin_id,days):    # Check if the file atl_{item['id']}.json exists and read it otherwise create it
    if path == 'hour':        
        if os.path.exists(f"{path_install(path)}\\{coin_id}.json") and modify_time(path,coin_id) is True:
            with open(f"{path_install(path)}\\{coin_id}.json", 'r') as f:
                hour = pd.read_json(f)
        else:
            hour = fetch_historical_prices(coin_id,days)
            # Save the DataFrame to a json file in the path {path_install('history')}
            hour.to_json(f"{path_install(path)}\\{coin_id}.json", orient='records')
        return hour
    elif path == 'atl':
        if os.path.exists(f"{path_install(path)}\\{coin_id}.json") and modify_time(path,coin_id) is True:
            with open(f"{path_install(path)}\\{coin_id}.json", 'r') as f:
                atl = pd.read_json(f)
        else:
            atl = fetch_all_time_low(coin_id)
            # Save the DataFrame to a json file in the path {path_install('history')}
            atl.to_json(f"{path_install(path)}\\{coin_id}.json", orient='records')
        return atl
    
def send_atl_coins(top_coins,days):    
    rsiprice ={}
    flattened_data = []
    number_of_checked_coins = 0
    number_of_passed_coins = 0
    for item in top_coins['data']:
        number_of_checked_coins += 1
        # Open c:\metalink\config\exclude.csv and if item['name'] is in the file then continue
        with open(f"{path_install('config')}exclude.csv", 'r') as f:
            exclude = f.read().splitlines()
        if item['id'] in exclude:
            continue
        item['priceUsd'] = float(item['priceUsd'])
        prices=check_file('hour',item['id'],days)
        #prices = fetch_historical_prices(item['id'], days)
        if prices is None:
            continue
        rsiprice['priceUsd'] = pd.Series([float(price) for price in prices['priceUsd']])
        # Ensure rsiprice is in the correct format for calculate_rsi
        #rsiprice_data = {'priceUsd': [rsiprice]}
        #rsiprice_df = pd.DataFrame(rsiprice_data)
        rsi = calculate_rsi(rsiprice, 16)
        #diverprices = {}
        #diverprices['priceUsd'] = (item['priceUsd'])
        divergences = find_divergences(rsiprice, rsi, item['name'])
        if divergences != []:
            print(divergences) 
        #if divergences == []:
        #    continue
        #else:
        #    print(divergences)
        #if divergences != []:
        #    # Print the last line of divergences
        #    divergent = print(divergences[-1])
        #    print(divergent['name'])       
        #if fetch_historical_prices(item['id'], days) is None:
        #    continue
        item['rsi'] = rsi.tail(1).values[0]
        ema200 = calculate_ema(prices, 200)
        item['ema200'] = ema200.tail(1).values[0]
        ema50 = calculate_ema(prices, 50)
        item['ema50'] = ema50.tail(1).values[0]
        if item['name'] is not None:
                item['name'] = item['name'].encode('ascii', 'replace').decode()
        if item['symbol'] is not None:
                item['symbol'] = item['symbol'].encode('ascii', 'replace').decode()
        if criteria(item) is False:
            #print(f"{item['name']} with price: {item['priceUsd']} and rsi: {item['rsi']} didn't passed the criteria")
            continue
        else:
            print(f"{item['name']} with price: {item['priceUsd']} and rsi: {item['rsi']} passed the criteria")
        # Fetch the all-time low for a coin
        #atl = fetch_all_time_low(item['id'])
        atl = check_file('atl',item['id'],days)
        #check_file('atl',item['id'])
        if atl is None:
            continue
        number_of_passed_coins += 1
        # Convert priceUsd to float
        atl = float(atl.iloc[0]['priceUsd'])
        # Create a flattened item with the required fields 
        flattened_item = {
            "id": item['id'],
            'name': item['name'],
            'priceUsd': item['priceUsd'],
            'symbol': item['symbol'],
            'atl': atl,
             'atl_change_percentage': (item['priceUsd'] - atl) / atl * 100,
            #'ath_date': item['ath_date'],
            'url': f"https://coinmarketcap.com/currencies/{item['id']}",
            'ema200': item['ema200'],
            'ema50': item['ema50'],
            'rsi': item['rsi']
        }
        flattened_data.append(flattened_item)
    if number_of_passed_coins > number_of_checked_coins * 0.12:
        print('The trend is BEARISH')
    else :
        print('The trend is BULLISH')
    print(f"Number of coins that were checked are : {number_of_checked_coins}")
    print(f"Number of coins that passed the ema are : {number_of_passed_coins}")
    if flattened_data == []:
        print("No coins for long...")
        return None
    # Convert the list of coins to a DataFrame
    df = pd.DataFrame(flattened_data)
    df.sort_values(by=['rsi'], inplace=True)
    df.reset_index(drop=True, inplace=True)
    normalize_message(df)
    
    return df.head(10)
    

# Calculate the hourly Exponential Moving Average (EMA) for a given period
def calculate_ema(prices, period):
    # Calculate the Exponential Moving Average (EMA)
    ema = prices['priceUsd'].ewm(span=period, adjust=False).mean()
    return ema

def criteria(item):
    # Check if the price is +- 5% of ema200
    if item['priceUsd'] < item['ema200'] * 0.95 or item['priceUsd'] > item['ema200'] * 1.20 or item['rsi'] > 31:
        return False
    
def calculate_rsi(prices, period):
    # Calculate the Relative Strength Index (RSI)
    rsi = ta.momentum.RSIIndicator(prices['priceUsd'], window=period).rsi()
    return rsi

def find_divergences(prices, rsi, coin_name):
    divergences = []
    for i in range(len(prices['priceUsd'])-13, len(prices['priceUsd']) - 1):
        # Check for bullish divergence
        if prices['priceUsd'].iloc[i] < prices['priceUsd'].iloc[i - 1] and prices['priceUsd'].iloc[i] < prices['priceUsd'].iloc[i + 1]:
            if rsi.iloc[i] > rsi.iloc[i - 1] and rsi.iloc[i] > rsi.iloc[i + 1]:
                divergences.append({'name':coin_name,'type': 'bullish', 'date': prices['time'].iloc[i], 'price': prices['priceUsd'].iloc[i], 'rsi': rsi.iloc[i]})
                print(f"Bullish divergence at time {prices['time'].iloc[i]} with price {prices['priceUsd'].iloc[i]} and RSI {rsi.iloc[i]}")
                exit()
        # Check for bearish divergence
        if prices['priceUsd'].iloc[i] > prices['priceUsd'].iloc[i - 1] and prices['priceUsd'].iloc[i] > prices['priceUsd'].iloc[i + 1]:
            if rsi.iloc[i] < rsi.iloc[i - 1] and rsi.iloc[i] < rsi.iloc[i + 1]:
                divergences.append({'name':coin_name,'type': 'bearish', 'date': prices['time'].iloc[i], 'price': prices['priceUsd'].iloc[i], 'rsi': rsi.iloc[i]})
                print(f"Bearish divergence at time {prices['time'].iloc[i]} with price {prices['priceUsd'].iloc[i]} and RSI {rsi.iloc[i]}")
    return divergences

def normalize_message(message):
    for index, row in message.head(10).iterrows():
        # Normalize values for the message
        row['atl_change_percentage'] = f"{row['atl_change_percentage']:.2f}%"
        # Format the price to a human-readable format
        row['priceUsd'] = f"${row['priceUsd']:.4f}"
        row['atl'] = f"${row['atl']:.4f}"
        row['ema200'] = f"${row['ema200']:.4f}"
        row['ema50'] = f"${row['ema50']:.4f}"
        # Convert the date to a human-readable format
        #row['ath_date'] = datetime.datetime.strptime(row['ath_date'], '%Y-%m-%dT%H:%M:%S.%fZ').strftime('%d-%m-%Y')      
        # Prepare the message for the coin
        coin_message = (f"*Name:* {row['name']}\n"
                        f"*Symbol:* {row['symbol']}\n"
                        f"*Price:* {row['priceUsd']}\n"
                        f"*EMA50:* {row['ema50']}\n"
                        f"*EMA200:* {row['ema200']}\n"
                        f"*Atl:* {row['atl']}\n"
                        f"*Atl change:* {row['atl_change_percentage']}\n"
                        f"*Url: *{row['url']}"        
        )
        #time.sleep(5)  # Wait for 5 second before sending the next message
        send_telegram_message(coin_message, None)
    return coin_message

# Send a message to a Telegram bot
def send_telegram_message(message, reply_to_message_id):
    # Your bot's token and chat ID
    with open(f"{path_install('config')}bot_token.txt", 'r') as f:
            bot_token = f.read().strip()
    with open(f"{path_install('config')}chat_id.txt", 'r') as f:
            chat_id = f.read().strip()
    with open(f"{path_install('config')}reply_to_message_id.txt", 'r') as f:
            reply_to_message_id = f.read().strip()
    send_text = f'https://api.telegram.org/bot{bot_token}/sendMessage?chat_id={chat_id}&parse_mode=Markdown&text={message}'
    if reply_to_message_id is not None:
        send_text += f'&reply_to_message_id={reply_to_message_id}'
    response = requests.get(send_text)
    return response.json()

def main():
    limit = 2001
    days = 0
    # Input the number of coins to fetch and the number of pages to scan
    print("Welcome to the metaLink Signals Bot...")
    print("This bot will fetch the top coins from CoinCap and send the coins with the lowest all-time low percentage to Telegram.")
    print("The bot will also calculate the hourly EMA200 and EMA50 for the coins.")
    while limit > 2000:
        print("Please enter the required parameters below: The maximum number of coins to fetch is 2000.")
        limit = int(input("Enter the number of coins to fetch: "))
    # Type 30 for the hourly EMA200 and EMA50 and 365 for the daily EMA200 and EMA50
    while days != 30 and days != 365:
        print("For the hourly EMA calculation type 30 and for the daily EMA calculation type 365")
        days = int(input("Enter the days for the EMA calculation: "))
    while True:
        print("Start scanning at...",datetime.now().strftime('%d-%m-%Y %H:%M:%S\n'))  
        top_coins = fetch_coins(limit)
        coinsbyid = send_atl_coins(top_coins,days)  # Call the function to send in telegram atl coins
        print("\n",coinsbyid)
        print("\nEnd of scanning at...",datetime.now().strftime('%d-%m-%Y %H:%M:%S\n'))
        time.sleep(240)  # Wait for 4 minutes before the next fetch

if __name__ == "__main__":
    check_modules()
    main()